## Script (Python) "request_gown"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Id: request_gown.py 3256 2008-02-29 06:51:46Z henrik $
"""
pay online
"""
import logging
from urllib import urlencode
logger = logging.getLogger('Skins.request_gown')
import DateTime
try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass

if context.portal_membership.isAnonymousUser():
    return None
wftool = context.portal_workflow
lt = context.portal_layouts
request = context.REQUEST
students = context.portal_url.getPortalObject().campus.students
student_id = context.getStudentId()
if student_id is None:
    return request.RESPONSE.redirect("%s/srp_anonymous_view" % context.portal_url())

student = getattr(students,student_id)
student_record = context.students_catalog.getRecordByKey(student_id)
session = context.getSessionId()

validate = request.has_key("cpsdocument_create_button")
res,psm,ds = lt.renderLayout(layout_id= 'student_gown',
                      schema_id= 'payment',
                      context=context,
                      mapping=validate and request,
                      ob={},
                      layout_mode="create",
                      formaction = "request_gown",
                      button = 'Pay',
                      commit = False,
                      )
if psm == 'invalid':
    psm = 'Please correct your errors!'
    return context.request_gown_form(rendered = res,
                                 psm = psm,
                                 mode = 'edit',
                                 #session_str = session[1],
                                 ds = ds,
                                 )
elif psm == '':
    return context.request_gown_form(rendered = res,
                                 psm = None,
                                 mode = 'edit',
                                 #session_str = session[1],
                                 ds = ds,
                                 )
elif psm == 'valid':
    pass
if "payments" not in student.objectIds():
    student.invokeFactory('PaymentsFolder','payments')
    payments = getattr(student,'payments')
    d = {}
    d['Title'] = 'Payments'
    payments.getContent().edit(mapping=d)
    wftool.doActionFor(payments,'open')
else:
    payments = getattr(student,'payments')
#from Products.zdb import set_trace; set_trace()
info = {}
p_id = "p%s" % ds.get('pin_n')
pin = str(ds.get('pin'))
try:
    cost = context.portal_pins(pin="".join(pin.split('-')))[0].cost
except:
    cost = "n/a"
try:
    x = float(cost)
except:
    cost = "n/a"

if not hasattr(payments,p_id):
    now = DateTime.DateTime()
    info['date'] = now
    info['amount'] = cost
    pin = info['order_id'] = "%s" % pin
    #info['type_code'] = "%s" % pin  #type_code is redundant and will be removed soon
    info['type_description'] = 'Gown Hire'
    info['type'] = 'sc'
    info['status'] = 'paid'
    info['session_id'] = session[0]
    info['item'] = ''
    info['category'] = 'gown'
    info['resp_code'] = "SC"
    info['resp_desc'] = "SC Payment Successful"
    payments.invokeFactory('Payment', p_id)
    payment = getattr(payments,p_id)
    wftool = context.portal_workflow
    wftool.doActionFor(payment,'open')
    payment.getContent().edit(mapping=info)
    wftool.doActionFor(payment,'close')


    logger.info('%s paid gown by scratch card' % student_id)
else:
    logger.info('%s repeatedly paid gown by scratch card' % student_id)
url = "%s/payments" % (student.absolute_url())
request.RESPONSE.redirect(url)

